//#define LOG_ENABLED

using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using AntsAI_bot_Surya1;
using System.Diagnostics;
using AStarAlgo;
using System.Timers;
using AntBot.Algorithms;

namespace Ants
{
    public class MyBot : Bot
    {
        public static List<Route> ListTimeout = new List<Route>();
        private List<Location> m_ListEnemyHills = new List<Location>();
        public static List<Location> m_ListFood = new List<Location>();
        public static List<Location> m_ListMyHills = new List<Location>();
        public static int g_iDistanceAllowed = 20;
        public static int g_iDistanceAllowedMin = 10;
        public static int g_iDistanceAllowedMax = 30;


#if LOG_ENABLED
		public static StreamWriter s_monStreamWriter = null;
        public static string g_textFileName = string.Empty;
#endif

        public int MapWidth
        {
            get
            {
                return GameState.Width;
            }
        }
        public int MapHeight
        {
            get
            {
                return GameState.Height;
            }
        }


        public enum eMovementType { Undefined = 0, AttackHills = 1, Explore = 2, DefendHill = 3, MoveFromHill = 4, CloseFood = 5, attackRange = 6, Food = 7, HillPatrol = 8 };


        // DoTurn is run once per turn
        public override void DoTurn(GameState state)
        {
            #region log
#if LOG_ENABLED
						Log(string.Format("**TURN N {0} **", GameState.g_tourNb), 18);
#endif
            #endregion

            state.UpdateVisibleMap();
            state.UpdateFightingMap();

            UpdateHillsAndFoodPosition(state);

            //STEP1:
            //DontStayOnMyHills
            DontGoThroughMyHills(state);

            ProtectMyHills_AttackEnemyHills_CollectFood(state);

            #region log AttackEnemyAnts Begin
#if LOG_ENABLED
						Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();
            Log(string.Format("*STEP Attacking enemy ants **"), 17);
#endif
            #endregion
            AttackEnemyAnts(state);
            #region log AttackEnemyAnts End
#if LOG_ENABLED
            stopWatch.Stop();
            Log(string.Format("*STEP Attacking enemy ants lasted {0} MS  ({1} ms left)*", stopWatch.ElapsedMilliseconds, state.TimeRemaining), 17);
            stopWatch.Reset();

#endif
            #endregion

            MakeAntsStayAroundMyHill(state);

            #region log ExploreMap Begin
#if LOG_ENABLED
            stopWatch.Start();
            Log(string.Format("*STEP5 ExploreMap  **"), 17);
#endif

            #endregion
            ExploreMap(state);
            #region log ExploreMap End
#if LOG_ENABLED
            stopWatch.Stop();
            Log(string.Format("*STEP5 Exploring the map lasted {0} MS  ({1} ms left)*", stopWatch.ElapsedMilliseconds, state.TimeRemaining), 17);
            stopWatch.Reset();
#endif
            #endregion


            MakeAntsStillOnMyHillsMove(state);


            double ratioTimeRemaining = (double)state.TimeRemaining / (double)GameState.TurnTime;
            if (ratioTimeRemaining > 0.3 && g_iDistanceAllowed < g_iDistanceAllowedMax)
            {
                g_iDistanceAllowed++;
                #region log
#if LOG_ENABLED
                Log(string.Format("*g_iDistanceAllowed INCREASED! new value = {0} **", g_iDistanceAllowed), 17);
#endif
                #endregion
            }


            //Logs
            #region log
#if LOG_ENABLED
            Log(string.Format("******** [TimeRemaining = {0}] [Ants number = {1} ] ********", state.TimeRemaining, state.MyAnts.Count), 18);
#endif
            #endregion

        }


        public int iMakeAntsStillOnMyHillsMoveDirInit = 0;
        /// <summary>
        /// Last minute change! Bad coding style I know!
        /// </summary>
        /// <param name="state"></param>
        private void MakeAntsStillOnMyHillsMove(GameState state)
        {
            if (GameState.IsTimeOutGlobal())
                return;

            List<Direction> ListDir = new List<Direction>();
            switch (iMakeAntsStillOnMyHillsMoveDirInit)
            {
                case 0:
                    {
                        ListDir.Add(Direction.East);
                        ListDir.Add(Direction.North);
                        ListDir.Add(Direction.West);
                        ListDir.Add(Direction.South);
                    }break;
                case 1:
                    {
                        ListDir.Add(Direction.North);
                        ListDir.Add(Direction.West);
                        ListDir.Add(Direction.South);
                        ListDir.Add(Direction.East);
                    } break;
                case 2:
                    {
                        ListDir.Add(Direction.West);
                        ListDir.Add(Direction.South);
                        ListDir.Add(Direction.East);
                        ListDir.Add(Direction.North);
                    } break;
                case 3:
                    {
                        ListDir.Add(Direction.South);
                        ListDir.Add(Direction.East);
                        ListDir.Add(Direction.North);
                        ListDir.Add(Direction.West);
                    } break;
            }

            foreach (AntHill hill in m_ListMyHills)
            {
                if (GameState.m_containsMyAnt[hill.Col, hill.Row])
                {
                    foreach (Direction dir in ListDir)
                    {
                        if (GameState.IsTimeOutGlobal())
                            return;

                        if (doMoveDirection(hill, dir, state, eMovementType.Explore, false))
                            break;
                    }
                }
            }
            iMakeAntsStillOnMyHillsMoveDirInit++;
            if (iMakeAntsStillOnMyHillsMoveDirInit > 3)
                iMakeAntsStillOnMyHillsMoveDirInit = 0;
        }

        private void MakeAntsStayAroundMyHill(GameState state)
        {
            #region Set a fix post
            Dictionary<Location, Location> m_DictDefendHill = new Dictionary<Location, Location>();

            eDefendType defendType = eDefendType.Nothing;
            int iMinimumAntNb = m_ListMyHills.Count * 5;
            if (m_ListMyHills.Count >= 4 )
                iMinimumAntNb = m_ListMyHills.Count * 3;

            if (state.MyAnts.Count > iMinimumAntNb)
                defendType = eDefendType.OnlyOne; 

            if (defendType != eDefendType.Nothing)
            {
                foreach (AntHill hill in m_ListMyHills)
                {
                    for (int i = 0; i < 4; i++)
                    {
                        Location locHill = new Location(hill.Row, hill.Col);
                        switch (i)
                        {
                            case 0: // north west
                                {
                                    locHill.AddColRow(-1, -1);
                                } break;

                            case 1: // north east
                                {
                                    locHill.AddColRow(1, -1);
                                } break;

                            case 2: // south east
                                {
                                    locHill.AddColRow(1, 1);

                                } break;
                            case 3: // south west
                                {
                                    locHill.AddColRow(-1, 1);
                                } break;
                        }

                        bool bSentinelSet = false;
                        if (GameState.m_mapWater[locHill.Col, locHill.Row] == false)
                        {
                            bSentinelSet = true;
                            Ant antSpot = new Ant(locHill.Row, locHill.Col, 0);

                            if (!state.MyAnts.Contains(antSpot))
                            {
                                List<Route> ListRoute = new List<Route>();
                                foreach (Ant antLoc in GameState.FreeAnts)
                                {
                                    if (GameState.IsTimeOutCompute())
                                        return;

                                    bool bTimeout = false;

                                    if (state.GetIsCloseEnoughFromTheAnt(antLoc, locHill, eMovementType.DefendHill))
                                    {
                                        List<MapPoint> listPoint = new List<MapPoint>();
                                        int distance = state.GetDistance(antLoc, locHill, ref bTimeout, ref listPoint);

                                        if (bTimeout)
                                        {

                                        }
                                        else
                                        {
                                            #region log
#if LOG_ENABLED
                                     // Log(string.Format("Distance pathfound = {0} (to go from ({1},{2}) to ({3},{4})", distance, antLoc.Col, antLoc.Row, foodLoc.Col, foodLoc.Row));
#endif
                                            #endregion
                                            Route route = new Route(antLoc, locHill, distance, eMovementType.DefendHill, listPoint);
                                            ListRoute.Add(route);
                                        }
                                    }
                                    else
                                    {
                                        #region log
#if LOG_ENABLED
                                 //Log(string.Format("It's too far : from ({0},{1}) dest ({2},{3}) : distance unPath=>{4}", antLoc.Col, antLoc.Row, foodLoc.Col, foodLoc.Row, distanceUnPath));
#endif
                                        #endregion
                                    }
                                }

                                ListRoute.Sort();
                                foreach (Route route in ListRoute)
                                {
                                    if (GameState.IsTimeOutCompute())
                                        return;

                                    if (!m_DictDefendHill.ContainsKey(route.getEnd()) && !m_DictDefendHill.ContainsValue(route.getStart()) && route.distance < 100)
                                    {
                                        if (doMoveLocation(route.getStart(), route.getEnd(), state, eMovementType.DefendHill))
                                        {
                                            m_DictDefendHill.Add(route.getEnd(), route.getStart());
                                        }
                                    }
                                }
                            }
                            else //Ants already placed should not move.
                            {
                                GameState.FreeAnts.Remove(new Ant(antSpot.Row, antSpot.Col, 0));
                            }
                        }
                        if (defendType == eDefendType.OnlyOne && bSentinelSet)
                            break;
                    }
                }
            }
            #endregion            
        }

        private void ProtectMyHills_AttackEnemyHills_CollectFood(GameState state)
        {
            Dictionary<Ant, int> dictNumberSentPerEnemy = new Dictionary<Ant, int>();
            List<Route> ListRoute = new List<Route>();

            #region DefendHills Routes
            #region log
#if LOG_ENABLED
					Log(string.Format("DEFEND HILLS"), 18);
					Stopwatch stopWatch = new Stopwatch();
					stopWatch.Start();						
#endif
            #endregion
            foreach (Ant enemyAnt in state.EnemyAnts)
            {
                AntHill myAntHillSpoted = null;


                if (!state.IsEnemyAntCloseFromMyHill(enemyAnt, ref myAntHillSpoted))
                    continue;


                foreach (Ant antLoc in GameState.FreeAnts)
                {
                    if (state.GetIsCloseEnoughFromTheAnt(antLoc, enemyAnt, eMovementType.DefendHill, 12))
                    {
                        if (GameState.IsTimeOutCompute())
                            continue;

                        bool bTimeout = false;
                        List<MapPoint> ListPoint = null;
                        int distance = state.GetDistance(antLoc, enemyAnt, ref bTimeout, ref ListPoint);
                        if (bTimeout || distance > 30)
                            continue;

                        Route route = new Route(antLoc, enemyAnt, distance, eMovementType.DefendHill, ListPoint);
                        ListRoute.Add(route);
                    }
                }
            }
            #region log
#if LOG_ENABLED
					Log(string.Format("DEFEND HILLS lasted {0} MS  ({1} ms left)", stopWatch.ElapsedMilliseconds, state.TimeRemaining), 18);
					stopWatch.Reset();
#endif
            #endregion
            #endregion

            #region Attack EnemyHills Routes
            #region log
#if LOG_ENABLED
					Log(string.Format("ATTACK ENEMY HILLS"), 18);
					stopWatch.Start();
#endif
            #endregion

            foreach (AntHill hill in m_ListEnemyHills)
            {
                foreach (Ant ant in GameState.FreeAnts)
                {
                    if (state.GetIsCloseEnoughFromTheAnt(ant, hill, eMovementType.AttackHills))
                    {
                        if (GameState.IsTimeOutCompute())
                            return;

                        bool bTimeout = false;
                        List<MapPoint> ListPoint = null;
                        int distance = state.GetDistance(ant, hill, ref bTimeout, ref ListPoint);
                        if (bTimeout)
                            continue;
                        Route route = new Route(ant, hill, distance, eMovementType.AttackHills, ListPoint);
                        ListRoute.Add(route);
                    }
                }
            }
            #region log
#if LOG_ENABLED
					Log(string.Format("ATTACK ENEMY HILLS lasted {0} MS  ({1} ms left)", stopWatch.ElapsedMilliseconds, state.TimeRemaining), 18);
					stopWatch.Reset();
#endif
            #endregion
            #endregion

            #region Harvesting Food Routes
            #region log
#if LOG_ENABLED
					Log(string.Format("HARVEST FOOD"), 18);
					stopWatch.Start();
#endif
            #endregion

            if (m_ListMyHills.Count != 0) //No hill, no worry about harvesting food.
            {
                foreach (Location foodLoc in m_ListFood)
                {
                    foreach (Ant antLoc in GameState.FreeAnts)
                    {
                        if (state.GetIsCloseEnoughFromTheAnt(antLoc, foodLoc, eMovementType.Food))
                        {
                            if (GameState.IsTimeOutCompute())
                                return;

                            bool bTimeout = false;
                            List<MapPoint> ListPoint = null;
                            int distance = state.GetDistance(antLoc, foodLoc, ref bTimeout, ref ListPoint);
                            if (bTimeout)
                                continue;
                            Route route = new Route(antLoc, foodLoc, distance, eMovementType.Food, ListPoint);
                            ListRoute.Add(route);
                        }
                    }
                }
            }
            #region log
#if LOG_ENABLED
					Log(string.Format("HARVEST FOOD lasted {0} MS  ({1} ms left)", stopWatch.ElapsedMilliseconds, state.TimeRemaining), 18);
					stopWatch.Reset();
#endif
            #endregion
            #endregion

            ListRoute.Sort(); //special sort (food is less important than enemy hills)

            Dictionary<Location, Location> m_DictFoodTargets = new Dictionary<Location, Location>();

            #region log
#if LOG_ENABLED
					Log(string.Format("APPLY ROUTES"), 18);
					stopWatch.Start();
#endif
            #endregion
            int iAntsAllowedToAttackHills = (int)(state.MyAnts.Count * 0.5); // Only 50% of the ants are allowed to attack hills (except if I don't have anymore hill)
            if (state.MyAnts.Count < 20)
                iAntsAllowedToAttackHills = (int)(state.MyAnts.Count * 0.4);
            if (state.MyAnts.Count > 100)
                iAntsAllowedToAttackHills = (int)(state.MyAnts.Count * 0.6);
            if (m_ListFood.Count == 0)
                iAntsAllowedToAttackHills = state.MyAnts.Count;

            foreach (Route route in ListRoute)
            {
                if (GameState.IsTimeOutGlobal())
                    return;

                switch (route.MvtType)
                {
                    case eMovementType.AttackHills:
                        {
                            if (iAntsAllowedToAttackHills-- > 0 || m_ListMyHills.Count == 0)
                                doMoveLocation(route.getStart(), route.getEnd(), state, eMovementType.AttackHills, route.ListPoint);
                        }
                        break;

                    case eMovementType.DefendHill:
                        {
                            Ant enemyAnt = new Ant(route.getEnd().Row, route.getEnd().Col, 0);
                            if (!dictNumberSentPerEnemy.ContainsKey(enemyAnt))
                                dictNumberSentPerEnemy.Add(enemyAnt, 0);

                            if (dictNumberSentPerEnemy[enemyAnt] < 3 && doMoveLocation(route.getStart(), route.getEnd(), state, eMovementType.DefendHill, route.ListPoint))
                            {
                                dictNumberSentPerEnemy[enemyAnt]++;
                                #region log
#if LOG_ENABLED
										Log(string.Format("Food order: going from ({0},{1}) to ({2},{3})", route.getStart().Col, route.getStart().Row, route.getEnd().Col, route.getEnd().Row), 15);
#endif
                                #endregion
                            }
                        }
                        break;

                    case eMovementType.Food:
                        {
                            if (!m_DictFoodTargets.ContainsKey(route.getEnd()) && !m_DictFoodTargets.ContainsValue(route.getStart()) && route.distance < 100)
                            {
                                if (doMoveLocation(route.getStart(), route.getEnd(), state, eMovementType.Food, route.ListPoint))
                                {
                                    m_DictFoodTargets.Add(route.getEnd(), route.getStart());
                                    #region log
#if LOG_ENABLED
											Log(string.Format("Food order: going from ({0},{1}) to ({2},{3})", route.getStart().Col, route.getStart().Row, route.getEnd().Col, route.getEnd().Row), 15);
#endif
                                    #endregion
                                }
                            }
                        }
                        break;
                }
            }
            #region log
#if LOG_ENABLED
					Log(string.Format("ROUTES APPLIED lasted {0} MS  ({1} ms left)", stopWatch.ElapsedMilliseconds, state.TimeRemaining), 18);
					stopWatch.Reset();
#endif
            #endregion
        }

        public void AttackEnemyAnts(GameState state)
        {
            List<Route> AttackRoutes = new List<Route>();
            List<Ant> sortedEnemyAnts = state.EnemyAnts;

            Dictionary<Ant, int> dictNumberSentPerEnemy = new Dictionary<Ant, int>();

            foreach (Ant enemyAnt in sortedEnemyAnts)
            {
                foreach (Ant antLoc in GameState.FreeAnts)
                {
                    if (GameState.IsTimeOutGlobal())
                        return;

                    bool bTimeout = false;

                    if (state.GetIsCloseEnoughFromTheAnt(antLoc, enemyAnt, eMovementType.attackRange,10))
                    {
                        //Log(string.Format("GatherFood : before = (to go from ({0},{1}) to ({2},{3})", antLoc.Col, antLoc.Row, foodLoc.Col, foodLoc.Row), 18);
                        List<MapPoint> ListPoint = null;
                        int distance = state.GetDistance(antLoc, enemyAnt, ref bTimeout, ref ListPoint);
                        if (bTimeout)
                            continue;
                        #region log
#if LOG_ENABLED
												//Log(string.Format(" GatherFood : Distance pathfound = {0} (to go from ({1},{2}) to ({3},{4})", distance, antLoc.Col, antLoc.Row, foodLoc.Col, foodLoc.Row), 18);
#endif
                        #endregion
                        Route route = new Route(antLoc, enemyAnt, distance, eMovementType.attackRange, ListPoint);
                        AttackRoutes.Add(route);
                    }
                    else
                    {
                    }
                }
            }

            AttackRoutes.Sort();
            foreach (Route route in AttackRoutes)
            {
                if (GameState.IsTimeOutGlobal())
                    return;

                Ant enemyAnt = new Ant(route.getEnd().Row, route.getEnd().Col, 0);
                if (!dictNumberSentPerEnemy.ContainsKey(enemyAnt))
                    dictNumberSentPerEnemy.Add(enemyAnt, 0);

                if (dictNumberSentPerEnemy[enemyAnt] < 3 && doMoveLocation(route.getStart(), route.getEnd(), state, eMovementType.attackRange, route.ListPoint))
                {
                    dictNumberSentPerEnemy[enemyAnt]++;
                    #region log
#if LOG_ENABLED
                        Log(string.Format("Food order: going from ({0},{1}) to ({2},{3})", route.getStart().Col, route.getStart().Row, route.getEnd().Col, route.getEnd().Row), 15);
#endif
                    #endregion
                }
            }
        }

        enum eDefendType { FourDiags, OnlyOne, Nothing };
        private bool doMoveLocation(Location antLoc, Location newLoc, GameState state, eMovementType movementType, List<AStarAlgo.MapPoint> listPoints = null)
        {

            if (listPoints == null)
                listPoints = FindWay(antLoc, newLoc);
            #region log
#if LOG_ENABLED
            Log(string.Format("doMoveLocation from ({0},{1}) to ({2},{3})", antLoc.Col, antLoc.Row, newLoc.Col, newLoc.Row), 0);
#endif
            #endregion
            Direction dPlanA = Direction.East;
            Direction dPlanB = Direction.East;

            Direction dBackA = Direction.East;
            Direction dBackB = Direction.East;

            bool bPlanBFound = false;

            if (listPoints != null)
            {
                if (listPoints.Count >= 2)
                {
                    GameState.FindDirections(antLoc, listPoints, ref dPlanA, ref dPlanB, ref bPlanBFound);

                    if (doMoveDirection(antLoc, dPlanA, state, movementType, true, listPoints.Count - 2))
                        return true;
                    else
                    {
                        if (doStayMove(antLoc, state))
                            return true;

                        /*if (dPlanA == Direction.East)
                            dBackA = Direction.West;
                        else if (dPlanA == Direction.West)
                            dBackA = Direction.East;
                        else if (dPlanA == Direction.South)
                            dBackA = Direction.North;
                        else if (dPlanA == Direction.North)
                            dBackA = Direction.South;

                        if (doMoveDirection(antLoc, dBackA, state, movementType, true, listPoints.Count-2))
                                return true;*/
                    }
                    return false;
                    /*else
                    {
                        if (bPlanBFound)
                        {

                        }
                        else
                        {
                            //ne pas bouger?
                            if (!doStayMove(antLoc))
                            {
                                //si ne pas bouger est dangereux: se casser
                                if (!doMoveDirection(antLoc, dBackA, state, movementType))
                                {
                                   if (!doMoveDirection(antLoc, dBackB, state, movementType))
                                   {
                                       return false;
                                   }
                                }
                            }
                            return true;
                        }
                        #region log
#if LOG_ENABLED
                        Log("doMoveDirection(antLoc, d, state) A RENVOYER FALSE");
#endif
                        #endregion
                        return false;
                    }*/
                }
                else
                    return false;
            }
            else
                return false;
        }

        public bool doStayMove(Location antLoc, GameState state)
        {
            bool bFight1v1 = state.IsLocInViewRangeFromOneOfMyHill(antLoc);
            bool bAntFloodTresh1 = GameState.m_mapVisible[antLoc.Col, antLoc.Row] > 20 && state.MyAnts.Count > 60;
            bool bAntFloodTresh2 = GameState.m_mapVisible[antLoc.Col, antLoc.Row] > 40 && state.MyAnts.Count > 100;

            if (GameState.m_fightStatusArray[0, antLoc.Col, antLoc.Row] == GameState.eFightingStatus.SAFE ||
                ((bFight1v1 || bAntFloodTresh1) && GameState.m_fightStatusArray[0, antLoc.Col, antLoc.Row] == GameState.eFightingStatus.KILL) ||
                (bAntFloodTresh2 && GameState.m_fightStatusArray[0, antLoc.Col, antLoc.Row] == GameState.eFightingStatus.DIE))
            {
                GameState.FreeAnts.Remove(new Ant(antLoc.Row, antLoc.Col, 0));
                return true;
            }
            else
            {
                return false;
            }
        }

        public bool doMoveDirection(Location antLoc, Direction direction, GameState state, eMovementType movementType, bool bCheckOtherSpot = true, int distanceToDest = -1)
        {
            if (GameState.IsTimeOutGlobal())
                return false;

            Location newLoc = state.GetDestination(antLoc, direction);

            if (!GameState.m_containsMyAnt[newLoc.Col, newLoc.Row] && state.GetIsPassable(newLoc) && state.GetIsNotFood(newLoc) && GameState.FreeAnts.Contains(new Ant(antLoc.Row, antLoc.Col, 0))
                && (state.MyAnts.Count <= 5 || !m_ListMyHills.Contains(newLoc)))
            {
                //Direction realDirection = Direction.North; //doesn't matter. Has to be initialized.
                bool bFight1v1 = (movementType == eMovementType.Food && distanceToDest < 3) || state.IsLocInViewRangeFromOneOfMyHill(antLoc);
                bool bAntFloodTresh1 = GameState.m_mapVisible[newLoc.Col, newLoc.Row] > 20 && (state.MyAnts.Count > 60 || m_ListMyHills.Count == 0);
                bool bAntFloodTresh2 = GameState.m_mapVisible[newLoc.Col, newLoc.Row] > 35 && (state.MyAnts.Count > 100 || m_ListMyHills.Count == 0);

                if (GameState.m_fightStatusArray[0, newLoc.Col, newLoc.Row] == GameState.eFightingStatus.SAFE ||
                    ((bFight1v1 || bAntFloodTresh1) && GameState.m_fightStatusArray[0, newLoc.Col, newLoc.Row] == GameState.eFightingStatus.KILL) ||
                    (bAntFloodTresh2 && GameState.m_fightStatusArray[0, newLoc.Col, newLoc.Row] == GameState.eFightingStatus.DIE))
                {
                    #region log
#if LOG_ENABLED
              Log(string.Format("MOVE : {0}  || ant({1},{2}) moves to Direction ({3}) **", movementType.ToString(), antLoc.Col, antLoc.Row, direction.ToString()), 18);
#endif
                    #endregion

                    IssueOrder(antLoc, direction);
                    GameState.m_containsMyAnt[antLoc.Col, antLoc.Row] = false;
                    GameState.m_containsMyAnt[newLoc.Col, newLoc.Row] = true;
                    GameState.FreeAnts.Remove(new Ant(antLoc.Row, antLoc.Col, 0));

                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                if (bCheckOtherSpot)
                {
                    Random rdm = new Random();

                    Direction dirChoice1 = Direction.East;
                    Direction dirChoice2 = Direction.East;
                    switch (direction)
                    {
                        case (Direction.North):
                            {
                                bool bValue =  (rdm.Next() % 2 == 1); 
                                dirChoice1 = bValue ? Direction.West : Direction.East;
                                dirChoice2 = bValue ? Direction.East : Direction.West;
                            } break;

                        case (Direction.East):
                            {
                                bool bValue =  (rdm.Next() % 2 == 1);
                                dirChoice1 = bValue ? Direction.South : Direction.North;
                                dirChoice2 = bValue ? Direction.North : Direction.South;
                            } break;
                        case (Direction.West):
                            {
                                bool bValue =  (rdm.Next() % 2 == 1);
                                dirChoice1 = bValue ? Direction.North : Direction.South;
                                dirChoice2 = bValue ? Direction.South : Direction.North;
                            } break;
                        case (Direction.South):
                            {
                                bool bValue =  (rdm.Next() % 2 == 1);
                                dirChoice1 = bValue ? Direction.East : Direction.West;
                                dirChoice2 = bValue ? Direction.West : Direction.East;
                            } break;
                    }

                    if (!doMoveDirection(antLoc, dirChoice1, state, movementType, false, distanceToDest))
                    {
                        if (!doMoveDirection(antLoc, dirChoice2, state, movementType, false, distanceToDest))
                        {
                            return false;
                        }
                    }
                    return true;
                }
                else
                    return false;
            }
        }

        public static List<MapPoint> FindWay(Location antLoc, Location finalLoc)
        {
            if (GameState.IsTimeOutGlobal())
                return null;

            Route route = new Route(antLoc, finalLoc, 0);
            if (MyBot.ListTimeout.Contains(route))
            {
                #region log
#if LOG_ENABLED
                Log(string.Format("Path-timeout saved utilis! from ({0},{1}) to ({2},{3})", route.start.Col, route.start.Row, route.end.Col, route.end.Row), 18);
#endif
                #endregion
                return null;
            }
            #region log
#if LOG_ENABLED
            Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();
#endif
            #endregion

            List<PathFinderNode> sol2 = GameState.myPathFinder.FindPath(antLoc, finalLoc);
            List<MapPoint> sol = new List<MapPoint>();
            if (sol2 != null && sol2.Count > 0)
            {
                foreach (PathFinderNode node in sol2)
                {
                    sol.Add(new MapPoint(node.Y, node.X));
                }
            }

            if (sol2 == null)
            {
                #region log
#if LOG_ENABLED
                    stopWatch.Stop();
                    Log(string.Format("Timeout inside FindWay ({0},{1}) to ({2},{3})  ({4}) ms spent", antLoc.Col, antLoc.Row, finalLoc.Col, finalLoc.Row, stopWatch.ElapsedMilliseconds), 15);
#endif
                #endregion
                if (!GameState.IsTimeOutCompute())
                    MyBot.ListTimeout.Add(route);
                return null;
            }
            return sol;
        }

        /// <summary>
        /// Game engine doesn't give info about hills if we can't see them (even for ours). Internal updates.
        /// </summary>
        /// <param name="state"></param>
        private void UpdateHillsAndFoodPosition(GameState state)
        {
            //Enemy hills
            #region Enemy hills
            foreach (AntHill hill in state.EnemyHills)
            {
                if (!m_ListEnemyHills.Contains(hill))
                    m_ListEnemyHills.Add(hill);
            }

            List<AntHill> listAntHillToRemove = new List<AntHill>();
            foreach (AntHill hill in m_ListEnemyHills)
            {
                if (GameState.m_mapLastTurnSeen[hill.Col, hill.Row] == GameState.g_tourNb)
                {
                    if (!state.EnemyHills.Contains(new AntHill(hill.Row, hill.Col, 0)))
                    {
                        listAntHillToRemove.Add(new AntHill(hill.Row, hill.Col, 0));
                    }
                }
            }

            foreach (AntHill hill in listAntHillToRemove)
            {
                m_ListEnemyHills.Remove(new Location(hill.Row, hill.Col));
                #region log
#if LOG_ENABLED
								Log(string.Format("Enemy hill removed ({0},{1})", hill.Col, hill.Row), 18);
#endif
                #endregion
            }
            #endregion

            //My hills
            #region My Hills
            foreach (AntHill hill in state.MyHills)
            {
                if (!m_ListMyHills.Contains(hill))
                    m_ListMyHills.Add(hill);
            }

            List<AntHill> listMyAntHillToRemove = new List<AntHill>();
            foreach (AntHill hill in m_ListMyHills)
            {
                if (GameState.m_mapLastTurnSeen[hill.Col, hill.Row] == GameState.g_tourNb)
                {
                    if (!state.MyHills.Contains(new AntHill(hill.Row, hill.Col, 0)))
                        listMyAntHillToRemove.Add(new AntHill(hill.Row, hill.Col, 0));
                }
            }

            foreach (AntHill hill in listMyAntHillToRemove)
            {
                m_ListMyHills.Remove(new Location(hill.Row, hill.Col));
                GameState.myPathFinder.ChangeSquareValue((ushort)hill.Row, (ushort)hill.Col, 1);
                #region log
#if LOG_ENABLED
								Log(string.Format("My hill removed ({0},{1})", hill.Col, hill.Row), 18);
#endif
                #endregion
            }
            #endregion

            //Food
            #region Food
            foreach (Location food in state.FoodTiles)
            {
                if (!m_ListFood.Contains(food))
                    m_ListFood.Add(food);
            }

            List<Location> listFoodToRemove = new List<Location>();
            foreach (Location food in m_ListFood)
            {
                if (GameState.m_mapLastTurnSeen[food.Col, food.Row] == GameState.g_tourNb)
                {
                    if (!state.FoodTiles.Contains(new Location(food.Row, food.Col)))
                        listFoodToRemove.Add(new Location(food.Row, food.Col));
                }
            }

            foreach (Location food in listFoodToRemove)
            {
                m_ListFood.Remove(new Location(food.Row, food.Col));
                #region log
#if LOG_ENABLED
					Log(string.Format("Food removed ({0},{1})", food.Col, food.Row), 18);
#endif
                #endregion
            }


            #endregion

        }

        private void ExploreMap(GameState state)
        {
            if (GameState.IsTimeOutGlobal())
                return;

            Location newLocationFarFarAway = new Location(0, 0);

            List<VisibleLocation> ListVisibility = new List<VisibleLocation>();

            List<Ant> listMyAntFree = new List<Ant>();
            foreach (Ant ant in GameState.FreeAnts)
            {
                listMyAntFree.Add(ant.Clone());
            }

            Dictionary<Ant, int> dictNumberSentPerEnemy = new Dictionary<Ant, int>();
            foreach (Ant ant in listMyAntFree)
            {
                int distanceToLookAt = state.ViewRadius;
                ListVisibility.Clear();

                if (GameState.IsTimeOutGlobal())
                    return;

                bool bPatchAttackEnemy = false;
                if (GameState.m_mapVisible[ant.Col, ant.Row] > 7) //Patch in order to fix some bad behaviour.
                {
                    //Let's see how many ants are around:
                    //If they're > 6 => go special way
                   int iOccur = 0;
                    for (int i = -4; i <= 4; i++)
                    {
                        for (int j = -4; j <= 4; j++)
                        {
                            if (i==0&&j==0)
                                continue;
                            Location locRef = new Location(ant.Row, ant.Col);
                            locRef.AddColRow(i, j);
                            if (GameState.m_containsMyAnt[locRef.Col, locRef.Row])
                                iOccur++;
                        }
                    }
                    
                   /* Location locEast = new Location(ant.Row, ant.Col);
                    locEast.AddColRow(4, 0);
                    if (GameState.m_mapVisible[locEast.Col, locEast.Row] > 5)
                        iOccur++;

                    Location locWest = new Location(ant.Row, ant.Col);
                    locEast.AddColRow(-4, 0);
                    if (GameState.m_mapVisible[locWest.Col, locWest.Row] > 5)
                        iOccur++;

                    Location locSouth = new Location(ant.Row, ant.Col);
                    locEast.AddColRow(0, 4);
                    if (GameState.m_mapVisible[locSouth.Col, locSouth.Row] > 5)
                        iOccur++;

                    Location locNorth = new Location(ant.Row, ant.Col);
                    locEast.AddColRow(0, -4);
                    if (GameState.m_mapVisible[locNorth.Col, locNorth.Row] > 5)
                        iOccur++;*/

                    if (iOccur >= 7) //mass ants: go to the first enemy
                    {
                        List<Route> AttackRoutes = new List<Route>();

                        List<Ant> ListEnemy = state.GetEnemyListOrderFromDistance(ant);
                        foreach (Ant enemyAnt in ListEnemy)
                        {
                            if (GameState.IsTimeOutGlobal())
                                return;

                            bool bTimeout = false;
                            

                            if (state.GetIsCloseEnoughFromTheAnt(enemyAnt, ant, eMovementType.attackRange, 45))
                            {
                                List<MapPoint> ListPoint = null;
                                int distance = state.GetDistance(ant, enemyAnt, ref bTimeout, ref ListPoint);
                                if (bTimeout)
                                    continue;

                                #region log
#if LOG_ENABLED
                                //Log(string.Format(" GatherFood : Distance pathfound = {0} (to go from ({1},{2}) to ({3},{4})", distance, antLoc.Col, antLoc.Row, foodLoc.Col, foodLoc.Row), 18);
#endif
                                #endregion

                                if (distance < 15)
                                    continue;

                                if (!dictNumberSentPerEnemy.ContainsKey(enemyAnt))
                                    dictNumberSentPerEnemy.Add(enemyAnt, 0);

                                if (dictNumberSentPerEnemy[enemyAnt] < 5 && doMoveLocation(ant, enemyAnt, state, eMovementType.Explore, ListPoint))
                                {
                                    dictNumberSentPerEnemy[enemyAnt]++;
                                    #region log
#if LOG_ENABLED
                                    Log(string.Format("Explore order (with enemy target): going from ({0},{1}) to ({2},{3})", ant.Col, ant.Row, enemyAnt.Col, enemyAnt.Row), 18);
#endif
                                    #endregion

                                    bPatchAttackEnemy = true;
                                    break;
                                }                                
                            }
                        }
                    }
                }

                if (bPatchAttackEnemy)
                    continue;


                #region log
#if LOG_ENABLED
                Log(string.Format("Dans ExploreMap, temps restant = {0} ms", state.TimeRemaining), 15);
#endif
                #endregion

                int ExtendedTurn = 0;
                while (ListVisibility.Count == 0)
                {
                    if (GameState.IsTimeOutGlobal())
                        return;

                    if (ExtendedTurn++ > 0)
                    {
                        distanceToLookAt += 1;
                    }

                    if (ExtendedTurn > 50)
                    {
                        break;
                    }

                    for (byte iter = 8; iter > 0; iter -= 2)
                    {
                        Location locMaybeUnseen = new Location(ant.Row, ant.Col);

                        switch (iter)
                        {
                            case 8:
                                //North
                                locMaybeUnseen.AddColRow(0, -(distanceToLookAt + 1));
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, 0, -1))
                                        continue;
                                }
                                break;

                            case 7:
                                //North/East
                                locMaybeUnseen.AddColRow(distanceToLookAt - 2 + 1, -(distanceToLookAt - 2 + 1));
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, 1, -1))
                                        continue;
                                }
                                break;

                            case 6:
                                //East:
                                locMaybeUnseen.AddColRow(distanceToLookAt + 1, 0);
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, 1, 0))
                                        continue;
                                }
                                break;

                            case 5:
                                //SouthEast
                                locMaybeUnseen.AddColRow(distanceToLookAt - 2 + 1, distanceToLookAt - 2 + 1);
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, 1, 1))
                                        continue;
                                }
                                break;

                            case 4:
                                //South:

                                locMaybeUnseen.AddColRow(0, distanceToLookAt + 1);
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, 0, 1))
                                        continue;
                                }
                                break;

                            case 3:
                                //South-West
                                locMaybeUnseen.AddColRow(-(distanceToLookAt - 2 + 1), distanceToLookAt - 2 + 1);
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, -1, 1))
                                        continue;
                                }
                                break;

                            case 2:
                                //West
                                locMaybeUnseen.AddColRow(-(distanceToLookAt + 1), 0);
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, -1, 0))
                                        continue;
                                }

                                break;
                            case 1:
                                //North-west
                                locMaybeUnseen.AddColRow(-(distanceToLookAt - 2 + 1), -(distanceToLookAt - 2 + 1));
                                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == true)
                                {
                                    //if (!FindEarthSpotFurther(ref locMaybeUnseen, -1, -1))
                                        continue;
                                }
                                break;
                        }
                        int turnSeen = GameState.m_mapLastTurnSeen[locMaybeUnseen.Col, locMaybeUnseen.Row];
                        //int turnSeen = GameState.m_mapVisible[locMaybeUnseen.Col, locMaybeUnseen.Row];
                        if (turnSeen != GameState.g_tourNb)
                        {
                            ListVisibility.Add(new VisibleLocation(locMaybeUnseen.Col, locMaybeUnseen.Row, turnSeen));
                        }
                    }
                }

                ListVisibility.Sort();

                foreach (VisibleLocation location in ListVisibility)
                {
                    if (GameState.IsTimeOutGlobal())
                        return;

                    if (!doMoveLocation(ant, location, state, eMovementType.Explore))
                    {
                        continue;
                    }
                    else
                    {
                        #region log
#if LOG_ENABLED
                            Log(string.Format("Explorer order: going from ({0},{1}) to ({2},{3})", ant.Col, ant.Row, location.Col, location.Row), 15);
#endif
                        #endregion
                        break;
                    }         
                }
            }
        }

        private bool FindEarthSpotFurther(ref Location locMaybeUnseen, int increaseColValue, int increaseRowValue, int increaseMax = 30)
        {
            for (int i = 0; i < increaseMax; i++)
            {
                locMaybeUnseen.AddColRow(increaseColValue, increaseRowValue);
                if (GameState.m_mapWater[locMaybeUnseen.Col, locMaybeUnseen.Row] == false)
                    return true;
            }
            return false;
        }

        private void DontGoThroughMyHills(GameState state)
        {
            foreach (AntHill hill in m_ListMyHills)
            {
                if (state.MyAnts.Count > 5)
                {
                    #region log
#if LOG_ENABLED
                    Log(string.Format("Hill position ({0},{1}) protected (added to orders)", hill.Col, hill.Row), 2);
#endif
                    #endregion
                    GameState.myPathFinder.ChangeSquareValue((ushort)hill.Row, (ushort)hill.Col, 0);
                }
                else
                {
                    GameState.myPathFinder.ChangeSquareValue((ushort)hill.Row, (ushort)hill.Col, 1);
                }
            }

        }

        public static void Main(string[] args)
        {
            /* #if DEBUG
                           System.Diagnostics.Debugger.Launch();
                           while (!System.Diagnostics.Debugger.IsAttached)
                           { }
               #endif*/
            new Ants().PlayGame(new MyBot());
        }

        public static void Log(string str, int priority = 0)
        {
            #region log
#if LOG_ENABLED

            if (priority >= 17)
                LogA(str);
#endif
            #endregion
        }

        public static void LogA(string txt)
        {
            #region log
#if LOG_ENABLED
						if (s_monStreamWriter == null)
							s_monStreamWriter = File.AppendText(g_textFileName + ".txt");
						s_monStreamWriter.Write(DateTime.Now.ToString("dd MMMM yyyy - hh:mm:ss.FFF FFF FFFF : "));
						s_monStreamWriter.WriteLine(txt);
						s_monStreamWriter.WriteLine(" ");
#endif
            #endregion
        }
    }
}