﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ants;
using AStarAlgo;

namespace AntsAI_bot_Surya1
{
    public class Route : IEquatable<Route>, IComparable
    {
        public Location start;
        public Location end;
        public int distance;
		public MyBot.eMovementType MvtType = MyBot.eMovementType.Undefined;
		public List<AStarAlgo.MapPoint> ListPoint = null;

        public Route()
        {

        }

				public Route(Location start, Location end, int distance)
				{
					this.start = start;
					this.end = end;
					this.distance = distance;
					this.MvtType = MyBot.eMovementType.Undefined;
				}

				public Route(Location start, Location end, int distance, MyBot.eMovementType mvtType, List<AStarAlgo.MapPoint> listPoint)
        {
            this.start = start;
            this.end = end;
            this.distance = distance;
						this.MvtType = mvtType;
						this.ListPoint = listPoint;
        }

        public Location getStart()
        {
            return start;
        }

        public Location getEnd()
        {
            return end;
        }

        public int getDistance()
        {
            return distance;
        }

        public int CompareTo(Object o)
        {
            int result = -1;
            if (typeof(Route) == o.GetType())
            {
                Route route = (Route)o;
                result = this.CompareTo(route);
            }
            return result;
        }

        public int CompareTo(Route route)
        {
					int iCoefThis = 1;
					int iCoefElse = 1;
					if (this.MvtType == MyBot.eMovementType.Food)
						iCoefThis = 3;
					if (route.MvtType == MyBot.eMovementType.Food)
						iCoefElse = 3;

					return distance * iCoefThis - route.distance * iCoefElse; 
        }


        override public bool Equals(Object o)
        {
            bool result = false;
            if (typeof(Route) == o.GetType())
            {
                Route route = (Route)o;
                result = (start == route.start && end == route.end);
            }
            return result;
        }

        public bool Equals(Route o)
        {
            bool bResult = (start.Col == o.start.Col && start.Row == o.start.Row && end.Col == o.end.Col && end.Row == o.end.Row);
            return bResult;
        }

        public override int GetHashCode() { return start.GetHashCode() * 10000 + end.GetHashCode(); }
    }

    public class RouteWithPath : Route, IEquatable<RouteWithPath>
    {
        public List<MapPoint> m_ListMapPoints = new List<MapPoint>();

        public RouteWithPath(Location newstart, Location newend, List<MapPoint> listMapPoint)
        {
              start = newstart;
              end = newend;
              m_ListMapPoints = listMapPoint;
        }

        public bool Equals(RouteWithPath o)
        {
            bool bResult = (start.Col == o.start.Col && start.Row == o.start.Row && end.Col == o.end.Col && end.Row == o.end.Row);
            return bResult;
        }

        public override int GetHashCode() { return start.GetHashCode() * 10000 + end.GetHashCode(); }

    }

}
    
